<?
/************************************************************************
 * Web Tools (WT) - a collection of web hosting tools                   *
 * Copyright (C) 2000-2004 Colin Verot - colin@verot.net                *
 *                                                                      *
 * This program is free software; you can redistribute it and/or modify *
 * it under the terms of the GNU General Public License as published by *
 * the Free Software Foundation; either version 2 of the License, or    *
 * (at your option) any later version.                                  *
 *                                                                      *
 * This program is distributed in the hope that it will be useful, but  *
 * WITHOUT ANY WARRANTY; without even the implied warranty of           *
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU    *
 * General Public License for more details.                             *
 *                                                                      *
 * You should have received a copy of the GNU General Public License    *
 * along with this program; if not, write to the                        *
 *    Free Software Foundation, Inc.                                    *
 *    59 Temple Place - Suite 330, Boston, MA  02111-1307, USA.         *
 ************************************************************************/

// user settings
$wt_cfg_auth                = false;
$wt_cfg_user                = "root"; 
$wt_cfg_pwd                 = "root";

// plugins settings
$wt_cfg_main_config_file    = "wt.cfg";
$wt_root_path               = ereg_replace("(.*)/([^/]*)", "\\1", $_SERVER['SCRIPT_FILENAME']) . "/";

// read the plugins parameters from wt.cfg
$wt_cfg_config_file = $wt_cfg_main_config_file;
wt_read_cfg_file();
for ($wt_cpt = 0; $wt_cpt < count($wt_cfg_item); $wt_cpt++) {
    if (!empty($wt_cfg_item[$wt_cpt])) {
        $wt_tmp = explode("|", $wt_cfg_item[$wt_cpt]);
        $wt_cfg_plugin[$wt_cpt][plugin]   = $wt_tmp[0];
        $wt_cfg_plugin[$wt_cpt][label]    = $wt_tmp[1];
        $wt_cfg_plugin[$wt_cpt][title]    = $wt_tmp[2];
        $wt_cfg_plugin[$wt_cpt][section]  = $wt_tmp[3];
    }
}
$wt_cfg_item = array();

// general settings
$wt_cfg_prog                = "Web Tools";
$wt_cfg_version             = "0.1";
$wt_cfg_copyright           = "&copy; 2004 <a href=\"http://www.verot.net\">Colin Verot</a>";

$wt_cfg_bad_chars_string	= '`~!@#$%^&*()+=[]{};\'\\:"|,/<>? ';
$wt_cfg_bad_chars_email	    = '`~!#$%^&*()+=[]{};\'\\:"|,/<>?, ';
$wt_cfg_bad_chars_name	    = '`~!@#$%^&*()+=[]{};\'\\:"|,/<>?';
$wt_cfg_bad_chars_path	    = '`~!@#$%^&*()+=[]{};\'"|,<>? ';

// perform auth
wt_auth();

$wt_error_occured = false;

// get the PHP version and redirect POST/GET variables
$wt_version = explode(".", phpversion());
if (intval($wt_version[0]) < 5 && intval($wt_version[1]) < 1) {
  $_POST   = $HTTP_POST_VARS;
  $_GET    = $HTTP_GET_VARS;
  $_SERVER = $HTTP_SERVER_VARS;
}

$wt_action  = wt_init_var('action');
$wt_section = wt_init_var('section');
$wt_plugin  = "";
$wt_label   = "";
$wt_title   = "";



for ($wt_cpt = 0; $wt_cpt < count($wt_cfg_plugin); $wt_cpt++) {
    if ($wt_cfg_plugin[$wt_cpt][section]==$wt_section) {
        $wt_plugin = $wt_cfg_plugin[$wt_cpt][plugin];
        $wt_label  = $wt_cfg_plugin[$wt_cpt][label];
        $wt_title  = $wt_cfg_plugin[$wt_cpt][title];
    }
}
// if we want the config/about section...
if ($wt_section == "config") $wt_plugin = "config";
if ($wt_section == "about") $wt_plugin = "about";


header ("Expires: Mon, 01 Jul 1997 05:00:00 GMT");
header ("Last-Modified: " . gmdate("D, d M Y H:i:s") . " GMT");
header ("Cache-Control: no-cache, must-revalidate");
header ("Pragma: no-cache");

?>
<html>
<head>
  <meta http-equiv="pragma" content="no-cache">
  <title><? echo $wt_cfg_prog; ?></title>
  <link rel="stylesheet" href="styles.php">
</head>


<body>
    <div id="adminframe">
        <div id="adminnav">
        	<h1>WebTools</h1>
            <hr />
            <div id="menu">
                <ul>
                <?            
                for ($wt_cpt = 0; $wt_cpt < count($wt_cfg_plugin); $wt_cpt++) {
                    echo "<li><a href=\"" . $PHP_SELF . "?section=" . $wt_cfg_plugin[$wt_cpt][section] . "\" class=\"frame-button\">" . $wt_cfg_plugin[$wt_cpt][label] . "</a></li>";
                }
                ?><li><a href="<? echo $PHP_SELF; ?>?section=config">configuration</a></li><li><a href="<? echo $PHP_SELF; ?>?section=about">about</a></li>
                </ul>
            </div>
            <hr />
            <p><? echo $wt_cfg_prog; ?></b>&nbsp;v.&nbsp;<? echo $wt_cfg_version; ?><br />
                <? echo $wt_cfg_copyright; ?></p>
        </div>

	    <div id="admincontent">
            <?
            if (!isset($wt_section)) { 
                // no section chosen; display homepage 
                echo "<center><br /><br /><br /><br /><br />$wt_cfg_prog<br /><br /><br /><br /><br /></center>";
            } else {
                // include wanted section
                $v = include("" . $wt_plugin . ".wt.php"); 
            }
            ?>
       </div>
    </div>       

    <br />
</body>
</html>





<?
function wt_auth() {
    global $wt_cfg_auth, $wt_cfg_user, $wt_cfg_pwd;
    global $_SERVER;

    if (!$wt_cfg_auth) return;

    if (($_SERVER['PHP_AUTH_USER'] != $wt_cfg_user) || ($_SERVER['PHP_AUTH_PW'] != $wt_cfg_pwd)) {
        header("WWW-Authenticate: Basic realm=\"$wt_cfg_prog\"");
        header("HTTP/1.0 401 Unauthorized");
        echo "<center><h3>Authentication failed.</h3>";
        echo "Click <a href=\"" . $PHP_SELF . "?\">here</a> to login again.</center>";
    exit;
    }
}

function wt_getmicrotime() {
   $wt_mtime = microtime();
   $wt_mtime = explode(" ",$wt_mtime);
   $wt_mtime = $wt_mtime[1] + $wt_mtime[0];
   return ($wt_mtime);
}

function wt_error($wt_msg) {
    global $wt_error_occured;
    $wt_exit = 0;
    if (func_num_args() == 2) {
        $wt_exit = func_get_arg(1);
    }
    echo "<p align=\"center\"><font class=\"bad\">$wt_msg</font><p>";
    $wt_error_occured = true;
    if ($wt_exit == 1) exit;
}

function wt_msg($wt_msg) {
    echo "<p align=\"center\"><font class=\"ok\">$wt_msg</font><p>";
}

function wt_is_valid_string($string) {
    global $wt_cfg_bad_chars_string;
    if (empty($string)) return true;
    for ($i = 0; $i < strlen($wt_cfg_bad_chars_string); $i++) {
        if (strstr($string, $wt_cfg_bad_chars_string[$i])) return true;
    }
    return false;
}

function wt_is_valid_email($string) {
    global $wt_cfg_bad_chars_email;
    if (empty($string)) return false;
    for ($i = 0; $i < strlen($wt_cfg_bad_chars_email); $i++) {
        if (strstr($string, $wt_cfg_bad_chars_email[$i])) return true;
    }
    return false;
}

function wt_is_valid_name($string) {
    global $wt_cfg_bad_chars_name;
    if (empty($string)) return false;
    for ($i = 0; $i < strlen($wt_cfg_bad_chars_name); $i++) {
        if (strstr($string, $wt_cfg_bad_chars_name[$i])) return true;
    }
    return false;
}

function wt_is_valid_path($string) {
    global $wt_cfg_bad_chars_path;
    if (empty($string)) return false;
    for ($i = 0; $i < strlen($wt_cfg_bad_chars_path); $i++) {
        if (strstr($string, $wt_cfg_bad_chars_path[$i])) return true;
    }
    return false;
}

function wt_init_file($wt_file) {
    if (!file_exists($wt_file)) return "missing";
    if (!is_readable($wt_file)) return "not readable";
    if (!is_writeable($wt_file)) return "not writeable";
    return "OK";
}

function wt_init_cfg_file($wt_file) {
    global $wt_cfg_main_config_file;
    if (empty($wt_file)) return "configuration file is not defined";
    if (!file_exists($wt_file)) {
        if ($wt_file != $wt_cfg_main_config_file) wt_msg("creating ".$wt_file."...");
        if (!($wt_file_handle = @fopen($wt_file, "w"))) {
            return "configuration file $wt_file is missing and can't be created";
        } else {
            fclose($wt_file_handle);
            if ($wt_file != $wt_cfg_main_config_file) wt_msg("... done");
            return "OK";
        } 
    }
    if (!is_readable($wt_file)) return "configuration file $wt_file is not readable";
    if (!is_writeable($wt_file)) return "configuration file $wt_file is not writeable";
    return "OK";
}

function wt_update_cfg_file() {
    global $wt_cfg_item, $wt_cfg_config_file;
    wt_write_cfg_file();
    $wt_cfg_item = array();
    wt_read_cfg_file();
}

function wt_read_cfg_file() {
    global $wt_cfg_item, $wt_cfg_config_file;
    $wt_res = wt_init_cfg_file($wt_cfg_config_file);
    if ($wt_res == "OK") {
        if (!($wt_file_handle = @fopen($wt_cfg_config_file, "r"))) {
            wt_error("could not read ".$wt_cfg_config_file." file");
            return false;
        }
        $wt_cpt = 0;
        while (!feof($wt_file_handle)) {
            $wt_file_line = fgets($wt_file_handle, 512);
            if (substr($wt_file_line, 0, 1) != "#" && trim($wt_file_line) != "") {
                $wt_cfg_item[$wt_cpt] = trim($wt_file_line);
                $wt_cpt++;
            }
        }
        fclose($wt_file_handle);
        return true;
    } else {
        wt_error($wt_res);
        return false;
    }
    return;
}

function wt_write_cfg_file() {
    global $wt_cfg_item, $wt_cfg_config_file;
    $wt_res = wt_init_cfg_file($wt_cfg_config_file);
    if ($wt_res == "OK") {
        if (!($wt_file_handle = @fopen($wt_cfg_config_file, "w"))) {
            wt_error("could not write ".$wt_cfg_config_file." file");
            return false;
        }        
        for ($wt_cpt = 0; $wt_cpt < count($wt_cfg_item); $wt_cpt++) {
            if (!empty($wt_cfg_item[$wt_cpt])) {
                fwrite($wt_file_handle, $wt_cfg_item[$wt_cpt]."\n");
            }
        }
        fclose($wt_file_handle);
    } else {
        wt_error($wt_res);
        return false;
    }
    return;
}

function wt_init_var($wt_var_name) {
	global $_POST, $_GET;
	$wt_var   = NULL;
	$wt_post_keys  = array_keys($_POST);
	$wt_get_keys   = array_keys($_GET);
	if (in_array($wt_var_name, $wt_post_keys)) {
        $wt_var = $_POST[$wt_var_name];
    } elseif (in_array($wt_var_name, $wt_get_keys)) {
        $wt_var = $_GET[$wt_var_name];
    } 
	return $wt_var;
}
?>